/*  QL Profiler program V1.0 Feb. 95		  */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <qdos.h>
#include <qptr.h>

struct	FNCINFO	{
							char	nom[30];
							long	address;
							long	nbfois;
							short ref;
							short status;
						};

struct	COMSTA	{
							struct JOBHEADER *header;	  /* Job header of target job */
							struct FNCINFO *base_of_table;
							short nb_fonction;
							long nb_time;
						} comsta;

/* prototypes */

void showjobh(long);
void order_add(struct FNCINFO *, struct FNCINFO *);
void order_fois(struct FNCINFO *, struct FNCINFO *);
struct FNCINFO *analyse_count(char *);
static long  AEXIT(struct WM_wwork *);
static long  AMOVE(struct WM_wwork *);
static long  ASTART(struct WM_wwork *);
static long  APAUSE(struct WM_wwork *);
static long  ASTOP(struct WM_wwork *);

/* end prototypes */

char	_prog_name[] = "QProf";
char	_conname[] = "con_2x1a0x0";
char	*_endmsg = NULL;
void	(*_consetup)() = NULL;
void	(*_cmdwildcards)() = NULL;

/* sprite definition */
extern struct WM_sprite  wm_sprite_move;

/* action routines */

struct	WM_action	aexit = {JSR, wm_actli, AEXIT};
struct	WM_action	amove = {JSR, wm_actli, AMOVE};
struct	WM_action	astart = {JSR, wm_actli, ASTART};
struct	WM_action	astop = {JSR, wm_actli, ASTOP};
struct	WM_action	apause = {JSR, wm_actli, APAUSE};

#include "defprof_inc"

struct	WM_wwork *gwwk;


struct FNCINFO *base1, *base2;
int  nb_fnc;
int  nb_run = 1;
FILE *out_result;
long rec_id, app_id;

int  main(int argc, char *argv[])
{
	char	buff[20],prog_name[50],map_name[50],result_name[50];
	long	chanid;
	int i,j, par_off, fd;
	struct qdirect f_h;
	struct REGS in,out;
	long start_recording = 1;
	unsigned long lengthofjob;
	char	*startofjob;

	gwwk = &ww;
	ww.chid = fgetchid(stdout);
	if (!wm_findv(ww.chid))
		exit (-1);
	ws.wwork = gwwk;	/* set cross reference */
	wm_prpos (gwwk,-1,0);
	wm_wdraw (gwwk);

	wm_swinf(gwwk,1,-1);

	sd_setin(ww.chid,-1,4);
	puts("Qprof by Franois Lanciault");
	puts("V1.0 Febuary 1995\n");

/* parametres */

	if(argc == 1)
	{
		printf("Error in parameter(s) !\n");
		mt_susjb(-1,250,NULL);
		exit(0);
	}

	par_off = 0;

	if(*argv[1] == '-')
	{
		if(*(argv[1]+1) == 'w')
			start_recording = 0;
		else
		{
			printf("Unknown switch %2s\n",argv[1]);
			mt_susjb(-1,250,NULL);
			exit(0);
		}
		argc--;
		par_off = 1;
	}

	switch(argc)
	{
		case 1:	printf("Error in parameter(s) !\n");
					mt_susjb(-1,250,NULL);
					exit(0);
					break;
		case 2:	sscanf(argv[1+par_off],"%s",prog_name);
					strcpy(map_name,prog_name);
					strcpy(result_name,prog_name);
					strcat(map_name,"_map");
					strcat(result_name,"_prof");
					break;
		case 3:	sscanf(argv[1+par_off],"%s",prog_name);
					sscanf(argv[2+par_off],"%s",map_name);
					strcpy(result_name,prog_name);
					strcat(result_name,"_prof");
					break;
		case 4:	sscanf(argv[1+par_off],"%s",prog_name);
					sscanf(argv[2+par_off],"%s",map_name);
					sscanf(argv[3+par_off],"%s",result_name);
					break;
	}


	comsta.nb_time = 0;

	out_result = fopen(result_name,"wb");
	if(out_result == NULL)
	{
		printf("Not able to creat file %s\n",result_name);
		mt_susjb(-1,150,NULL);
		exit(0);
	}

	printf("Prog: %s\nMap file: %s\nResult: %s\n",prog_name,map_name,result_name);
	fprintf(out_result,"Qprof v1.0\n\nProg: %s\nMap file: %s\nResult: %s\n\n",prog_name,map_name,result_name);

	puts("Analysing MAP file...");
	base1 = analyse_count(map_name);
	base2 = calloc(nb_fnc+3,sizeof(struct FNCINFO));
	comsta.base_of_table = base2;

	puts("Ordering functions...");
	order_add(base1,base2);

	puts("Loading program in memory...");
	fd = open(prog_name,O_RDONLY);
	if(fd == -1)
	{
		printf("Progam %s not found!\n",prog_name);
		mt_susjb(-1,150,NULL);
		exit(0);
	}

	chanid = getchid(fd);
	fs_headr(chanid,-1,&f_h,sizeof(struct qdirect));

	lengthofjob = f_h.d_length;

	for(i=0;i<36;i++)
	{
		if(*(f_h.d_name+i) != ' ')
		{
			for(j=i;j<35;j++)
				*(f_h.d_name + j - i) = *(f_h.d_name + j);

			*(f_h.d_name + j - i) = 0;
			break;
		}
	}

	printf("Name: %s\n",f_h.d_name);
	printf("Length : %d\n",lengthofjob);
	printf("Type : %d\n",f_h.d_type);
	printf("Data length : %d\n",f_h.d_datalen);

	fprintf(out_result,"*** File Header ***\n");
	fprintf(out_result,"Name: %s\n",f_h.d_name);
	fprintf(out_result,"Length : %d\n",lengthofjob);
	fprintf(out_result,"Type : %d\n",f_h.d_type);
	fprintf(out_result,"Data length : %d\n",f_h.d_datalen);

	if(f_h.d_type == QF_PROG_TYPE)
	{
		in.D0 = 1;
		in.D1 = -1;
		in.D2 = lengthofjob;
		in.D3 = f_h.d_datalen;

		in.A1 = NULL;
		qdos1(&in,&out);
		app_id = out.D1;
		startofjob = out.A0;

		showjobh(startofjob);

		fs_load(chanid,startofjob,lengthofjob);
		close(fd);

		comsta.header = (struct JOBHEADER *)(startofjob - 0x68);

		base2->address = -9999999;
		base2->nbfois = 0;
		(base2 + nb_fnc + 1)->address = lengthofjob;
		(base2 + nb_fnc + 1)->nbfois = 0;
		(base2 + nb_fnc + 2)->address = 999999999;
		(base2 + nb_fnc + 2)->nbfois = 0;
	}
	else
	{
		close(fd);
		printf("Progam %s is not executable!\n",prog_name);
		mt_susjb(-1,150,NULL);
		exit(0);
	}


												/* Start recording job */
	puts("Starting recording program...");
	sprintf(buff,"%d",&comsta);
	rec_id = forklp("recorder_exe",-1L,"recorder",buff,"");
	if(rec_id == -1)
		exit(-7);

												/* At this point, the recording job is suspended */
												/* now start application program */
	puts("Starting application program...");
	mt_activ(app_id,32,0);
												/* release scaning job if opt. -s has been specified */
	if(start_recording)
	{
		ww.wstat->litem[lit_start] = WSI_MKUN;   /* set make unavailable */
		ww.wstat->litem[lit_pause] = WSI_MKAV;   /* set make available */
		ww.wstat->litem[lit_stop] = WSI_MKAV;	  /* set make available */
		wm_ldraw (gwwk,-1);								  /* and re-draw */
		fprintf(out_result,"\nStart of run #%d\n",nb_run);
		mt_reljb(rec_id);
	}
												/* go get instruction from pointer */
	while (!wm_rptr(gwwk));
}

void showjobh(long base)
{
	struct JOBHEADER *j_h;

	j_h = (struct JOBHEADER *)(base - 0x68);

	fprintf(out_result,"\n*** JOB Header ***\n\n");
	fprintf(out_result,"Total length  : %d\n",j_h->jb_len);
	fprintf(out_result,"Start address : %d\n",j_h->jb_start);
	fprintf(out_result,"Owner         : %d\n",j_h->jb_owner);
	fprintf(out_result,"Tag           : %d\n",j_h->jb_tag);
	fprintf(out_result,"Priority      : %d\n",j_h->jb_princ);
	fprintf(out_result,"Program counter : %d\n\n",j_h->jb_regs.jb_PC);
}

struct FNCINFO *analyse_count(char *map_name)
{
	char	input_buffer[100];
	int	nb_fonction = 0;
	FILE	*fp;
	long	dummy;
	struct FNCINFO *base;


	fp = fopen(map_name,"rb");
	if(fp == NULL)
	{
		printf("Map file %s not found!\n",map_name);
		mt_susjb(-1,150,NULL);
		exit(0);
	}

	while(!feof(fp))
	{
		fgets(input_buffer,100,fp);

		if(strnicmp(input_buffer,"Symbol Table",12) == 0)
		{
			while(!feof(fp))
			{
				input_buffer[42] = '|';
				fgets(input_buffer,100,fp);

				if(strnicmp((input_buffer + 42),"TEXT",4) == 0)
					nb_fonction++;
			}
		}
	}

	rewind(fp);
	base = calloc(nb_fonction+3,sizeof(struct FNCINFO));
	nb_fonction = 0;

	while(!feof(fp))
	{
		fgets(input_buffer,100,fp);

		if(strnicmp(input_buffer,"Symbol Table",12) == 0)
		{
			while(!feof(fp))
			{
				input_buffer[42] = '|';
				fgets(input_buffer,100,fp);

				if(strnicmp((input_buffer + 42),"TEXT",4) == 0)
				{
					strncpy((base + nb_fonction+1)->nom,input_buffer,21);
					sscanf((input_buffer + 21),"%8x",&dummy);
					(base + nb_fonction+1)->address = dummy;
					(base + nb_fonction+1)->nbfois = 0;
					(base + nb_fonction+1)->ref = nb_fonction+1;

					nb_fonction++;
				}

			}
		}
	}
	printf("Number of functions : %d\n",nb_fonction);
	fprintf(out_result,"\nNumber of functions : %d\n\n",nb_fonction);
	fclose(fp);
	comsta.nb_fonction = nb_fnc = nb_fonction;
	return base;
}

void order_add(struct FNCINFO *from, struct FNCINFO *to)
{
	short i, j, low;
	long	high;

	for(i=1;i<=nb_fnc;i++)
	{
		high = 99999999;
		for(j=1;j<=nb_fnc;j++)
		{
			if((from + j)->address < high)
			{
				high = (from + j)->address;
				low = j;
			}
		}
		(from + low)->address = 99999999;
		(to + i)->address = high;
		(to + i)->ref = low;
		(to + i)->status = 0;
		(to + i)->nbfois = 0;
		strncpy((to + i)->nom,(from + low)->nom,30);
	}
}

void order_fois(struct FNCINFO *from, struct FNCINFO *to)
{
	short i, j, low;
	long	high;

	for(i=0;i<=nb_fnc+1;i++)
	{
		high = -99999999;
		for(j=0;j<=nb_fnc+1;j++)
		{
			if((from + j)->nbfois > high)
			{
				high = (from + j)->nbfois;
				low = j;
			}
		}
		(from + low)->nbfois = -99999999;
		(to + i)->address = (from + low)->address;
		(to + i)->ref = low;
		(to + i)->status = 0;
		(to + i)->nbfois = high;
		strncpy((to + i)->nom,(from + low)->nom,30);
	}

	for(i=0;i<=nb_fnc+1;i++)
		(from + i)->nbfois = 0;
}

/* Action routines */

static long  AEXIT(struct WM_wwork *wwk)
{
	fclose(out_result);
	exit(0);
}

static long  AMOVE(struct WM_wwork *wwk)
{
	short dx,dy;

	wwk->wstat->evnt |= PT_WMOVE; 		/* set event bit for wm_chwin */
	wm_chwin(wwk,&dx,&dy);

	wwk->wstat->litem[lit_move] = WSI_MKAV;	/* set make available */
	return wm_ldraw (wwk,-1);						/* and re-draw */
}

static long ASTART(struct WM_wwork *wwk)
{
	fprintf(out_result,"\nStart of run #%d\n",nb_run);
	mt_reljb(rec_id);

	wwk->wstat->litem[lit_start] = WSI_MKUN;	 /* set make unavailable */
	wwk->wstat->litem[lit_pause] = WSI_MKAV;	 /* set make available */
	wwk->wstat->litem[lit_stop] = WSI_MKAV;	/* set make available */
	return wm_ldraw (wwk,-1);						/* and re-draw */
}

static long ASTOP(struct WM_wwork *wwk)
{
	int i;
	unsigned long tot_read, out_read;

	tot_read = comsta.nb_time;
	out_read =	base2->nbfois + (base2 + nb_fnc + 2)->nbfois;

	mt_susjb(rec_id,-1,NULL);
	mt_susjb(app_id,-1,NULL);

	fprintf(out_result,"Number of reading inside application program  : %7d (%4.1f%%)\n",tot_read-out_read,100.0 * ((double)tot_read-(double)out_read)/(double)tot_read);
	fprintf(out_result,"Number of reading outside application program : %7d (%4.1f%%)\n",out_read,100.0 * (double)out_read/(double)tot_read);

	fprintf(out_result,"\nComplete list.\n\n");
	for(i=1;i<=nb_fnc;i++)
		fprintf(out_result,"%4d:  name:%15.15s  address:%8x  count:%6d (%4.1f%%) ref:%d\n",i,(base2+i)->nom,(base2+i)->address,(base2+i)->nbfois,(double)(100.0 * (double)(base2+i)->nbfois / (double)tot_read),(base2+i)->ref);

	order_fois(base2, base1);

	fprintf(out_result,"\n\nOrdered list.\n\n");
	for(i=0;i<=nb_fnc;i++)
		if((base1 + i)->nbfois != 0)
			fprintf(out_result,"%4d:  name:%15.15s  address:%8x  count:%6d (%4.1f%%)\n",i,(base1+i)->nom,(base1+i)->address,(base1+i)->nbfois,(double)(100.0 * (double)(base1+i)->nbfois / (double)tot_read));

	fprintf(out_result,"\n\nEnd of run #%d\n",nb_run);
	nb_run++;
	comsta.nb_time = 0;

	mt_reljb(app_id);

	wwk->wstat->litem[lit_stop] = WSI_MKUN;	/* set make unavailable */
	wwk->wstat->litem[lit_pause] = WSI_MKUN;	 /* set make unavailable */
	wwk->wstat->litem[lit_start] = WSI_MKAV;	 /* set make available */
	return wm_ldraw (wwk,-1);						/* and re-draw */
}

static long APAUSE(struct WM_wwork *wwk)
{
	if(wwk->wstat->litem[lit_pause])
		mt_susjb(rec_id,-1,NULL);
	else
		mt_reljb(rec_id);

	return 0;
}
